module Peatio
  module Decredcoin
    module Hooks
      BLOCKCHAIN_VERSION_REQUIREMENT = "~> 1.0.0"
      WALLET_VERSION_REQUIREMENT = "~> 1.0.0"

      class << self
        def check_compatibility
          unless Gem::Requirement.new(BLOCKCHAIN_VERSION_REQUIREMENT)
                     .satisfied_by?(Gem::Version.new(Peatio::Blockchain::VERSION))
            [
                "Decredcoin blockchain version requirement was not suttisfied by Peatio::Blockchain.",
                "Decredcoin blockchain requires #{BLOCKCHAIN_VERSION_REQUIREMENT}.",
                "Peatio::Blockchain version is #{Peatio::Blockchain::VERSION}"
            ].join('\n').tap { |s| Kernel.abort s }
          end

          unless Gem::Requirement.new(WALLET_VERSION_REQUIREMENT)
                     .satisfied_by?(Gem::Version.new(Peatio::Wallet::VERSION))
            [
                "Decredcoin wallet version requirement was not satisfied by Peatio::Wallet.",
                "Decredcoin wallet requires #{WALLET_VERSION_REQUIREMENT}.",
                "Peatio::Wallet version is #{Peatio::Wallet::VERSION}"
            ].join('\n').tap { |s| Kernel.abort s }
          end
        end

        def register
          Peatio::Blockchain.registry[:decredcoin] = Decredcoin::Blockchain
          Peatio::Wallet.registry[:decredcoind] = Decredcoin::Wallet
        end
      end

      if defined?(Rails::Railtie)
        require "peatio/decredcoin/railtie"
      else
        check_compatibility
        register
      end
    end
  end
end
